'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                 Manager                                  |
'|                                                                          |
'|                           WinLIFT task manager                           |
'|              Based on ZAP manager from "ZAP Image solution"              |
'|                                                                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|            8 Domaine de Rochagnon. 38800 Champagnier  FRANCE             |
'|                       http://www.zapsolution.com                         |
'|                    E-mail: pterrier@zapsolution.com                      |
'|                                                                          |
'|                   copyright (c) 1999 Patrice TERRIER                     |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 01-01-2000                         |
'|                        Last revised : 01-02-2000                         |
'+--------------------------------------------------------------------------+

' ** Eliminate unnecessary macros
%NOANIMATE    = 1
%NODRAGLIST   = 1
%NOHEADER     = 1
%NOIMAGELIST  = 1
%NOLISTVIEW   = 1
%NOTABCONTROL = 1
%NOTRACKBAR   = 1
%NOTREEVIEW   = 1
%NOUPDOWN     = 1

%NOBUTTON     = 1
%NOCOMBOEX    = 1
%NOEDIT       = 1
%NOCOMBO      = 1
%NOLIST       = 1
%WINAPI       = 1
%NOREBAR      = 1
%NOTOOLBAR    = 1
%NOTOOLTIPS   = 1
%NOSTATUSBAR  = 1

#COMPILE EXE

#INCLUDE "WIN32API.INC"
#INCLUDE "SKENGINE.INC"
#RESOURCE "MANAGER.PBR"

GLOBAL Radical$
GLOBAL zTruePath AS ASCIIZ * 128
GLOBAL hInst&, hFont&
GLOBAL hFrame&, hMenu&, hCTL&, hStatus&
GLOBAL sk AS SKALL
GLOBAL Mact$()
GLOBAL cfgStr$()
GLOBAL zTmp AS ASCIIZ * 256
GLOBAL zResult AS ASCIIZ * 256
GLOBAL ScrWidth&, ScrHeight&

FUNCTION WndProc& (BYVAL hWnd&, BYVAL Msg&, BYVAL wParam&, BYVAL lParam&) EXPORT

    LOCAL rc     AS RECT
    LOCAL ps     AS PAINTSTRUCT
    LOCAL zClass AS ASCIIZ * 256
    LOCAL zName  AS ASCIIZ * 256
   
    Ret& = skGetMessage(hWnd&, Msg&, wParam&, lParam&)
    IF Ret& THEN FUNCTION = Ret&: EXIT FUNCTION

    wP& = LOWRD(wParam&)

    SELECT CASE Msg&

    CASE %WM_SYSCOMMAND
	 IF wParam& = %SC_CLOSE THEN

            DIM cXY AS POINTAPI

	    CALL ShowWindow(hFrame&, %SW_RESTORE)
	    CALL GetWindowRect (hFrame&, rc)
	    x& = rc.nLeft
	    y& = rc.nTop
	    Wdth& =  rc.nRight - rc.nLeft
	    Hght& = rc.nBottom - rc.nTop
            IF hZbox& THEN
               cXY.X = -5: cXY.Y = -5: CALL ClientToScreen(hZbox&, cXY)
               xZoom& = cXY.X: yZoom& = cXY.Y
            END IF

          ' Evite bug GetWindowRect retourne mauvaise valeur pour cXY.X et CXY.Y
            cXY.X = 0: cXY.Y = 0: CALL ClientToScreen(hFrame&, cXY)
	    CALL Config (Radical$ + ".CFG", cXY.X, cXY.Y, Wdth&, Hght&, 1)

            IF hZoom& THEN CALL DestroyWindow(hZoom&)
            IF sMenu& THEN CALL DestroyMenu(sMenu&): sMenu& = 0

            CALL PostQuitMessage(0)
	    FUNCTION = 1: EXIT FUNCTION
	 ELSEIF wParam& = 0 THEN

            tNotify$ = skAuthor$ + "||ZAP Image solution|http://www.zapsolution.com|e-mail: pterrier@infonie.fr|| copyright " + RIGHT$(DATE$, 4) + " Patrice Terrier|All rights reserved."
	    sk.Icon = LoadIcon(hInst&, "PROGRAM")
	    sk.Edge = %EDGE_ETCHED
	    sk.Just = %SK_CENTERED
	    sk.Effect = %SK_CENTERED
            sk.Print3D = %SK_3DOUT
            sk.Fore = skGetSysColor(%SKCOLOR_WINDOWTEXT)
            sk.Back = skGetSysColor(%SKCOLOR_WINDOW)
   	  ' UseButton$ = "Button1|Button2|Button3"  
	    UseButton$ = "" ' Uses the default "ok" button

            CALL skMsgBox(hFrame&, skCaptionFont, skGetCTLText(hFrame&), tNotify$, UseButton$, sk)
	    
	 END IF
    CASE %WM_COMMAND

	 IF skMacte$(wP&, Mact$()) = "END" THEN
	    CALL SendMessage (hWnd&, %WM_SYSCOMMAND, %SC_CLOSE, lParam&)
	    FUNCTION = 1: EXIT FUNCTION
	 END IF

         Item$ = skMacte$(wP&, Mact$())            ' Get the menu action to perform.
         ProgName$ = skFindF(Item$)                ' Search the requested file.
         IF LEN(ProgName$) THEN                    ' File has been found.
            CALL skShell(ProgName$, %SW_SHOW, 0)   ' Run it.
         END IF
         
    CASE %WM_MOUSEMOVE    
    END SELECT

    FUNCTION = DefWindowProc(hWnd&, Msg&, wParam&, lParam&)

END FUNCTION

FUNCTION WinMain (BYVAL hInstance     AS LONG, _
		  BYVAL hPrevInstance AS LONG, _
		  lpCmdLine           AS ASCIIZ PTR, _
		  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL rc          AS RECT
    LOCAL wc          AS WndClassEx
    LOCAL szClassName AS ASCIIZ * 32
    
    REDIM PopMnu$(0), Mact$(0, 0), cfgStr$(0)

  ' Detect the true name of the running application.
    CALL skSplitN(skExeName, TruePath$, TrueName$)

    zTruePath = TruePath$
    hInst& = hInstance&
    hFont& = skDefaultFont

    ScrWidth& = GetSystemMetrics(%SM_CXSCREEN)
    ScrHeight& = GetSystemMetrics(%SM_CYSCREEN)

    Radical$ = EXTRACT$(skExeName, ".")

    ConfigFile$ = Radical$ + ".SYS"
    IF NOT skExist(ConfigFile$) THEN
       nNotify$ = ConfigFile$ + " missing !"
       sk.Icon = LoadIcon(%NULL, BYVAL %IDI_ERROR)
       sk.Edge = %EDGE_ETCHED
       sk.Just = %SK_CENTERED
       sk.Effect = %SK_CENTERED
       sk.Fore = skGetSysColor(%SKCOLOR_CAPTIONTEXT)
       sk.Back = skGetSysColor(%SKCOLOR_ACTIVECAPTION)
       CALL skMsgBox(0, hFont&, "Error", nNotify$, "", sk)
       FUNCTION = 2 ' ERROR_FILE_NOT_FOUND
       EXIT FUNCTION
    END IF

    hIcon& = LoadIcon(hInstance&, "PROGRAM")

  ' Read dynamicaly menu bar + menu popups with their related actions.
    CALL skReadM(ConfigFile$, BarMnu$, PopMnu$(), Mact$(), Done&)
  
  ' Create the skin menu  
    hMenu& = skMenu&(BarMnu$, PopMnu$(), Mact$())
  
  ' Read dynamic messages
    CALL skReadStr(ConfigFile$, cfgStr$(), Done&)

  ' Retrieves last user window coordinates in the config file
    CALL Config (Radical$ + ".CFG", x&, y&, xFrame&, yFrame&, 0)


    AppTitle$ = cfgStr$(1) ' "WinLIFT m a n a g e r"
    zTmp = AppTitle$: szClassName = "WLMANAGER"

  ' Create yhe Main Skin window
    Style& = %CS_HREDRAW OR %CS_VREDRAW
    
    wc.cbSize        = SIZEOF(wc)
    wc.style         = Style&
    wc.lpfnWndProc   = CODEPTR(WndProc)
    wc.cbClsExtra    = 0
    wc.cbWndExtra    = 0
    wc.hInstance     = hInst&
    wc.hIcon         = %NULL
    wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
    wc.hbrBackground = %NULL ' Don't paint the class window background
    wc.lpszMenuName  = %NULL
    wc.lpszClassName = VARPTR(szClassName)
    wc.hIconSm       = LoadIcon(hInst&,"PROGRAM")

    CALL RegisterClassEx(wc)
 
    CALL skAppTitle(AppTitle$) ' Tell the Engine the Application's name being used
                               ' to let him compute the good skXmini size
                               
    Style& = %WS_POPUP OR %WS_SYSMENU' OR %WS_CLIPCHILDREN
    StyleEx& = %WS_EX_APPWINDOW + %WS_EX_TOPMOST
    CALL skWindowStyle(%SK_MINIMIZEBOX OR %SK_CLOSEBOX)

    Xin& = skXmini - skGetSystemMetrics(%SK_CXFRAMELEFT) - skGetSystemMetrics(%SK_CXFRAMERIGHT)
    Yin& = 0
    CALL skSetMaxSize(Xin&, Yin&, xFrame&, yFrame&)
    
    hFrame& = CreateWindowEx(StyleEx&, _
                          szClassName, _           ' window class name
                          zTmp, _                  ' window title
                          Style&, _                ' window style
                          x&, _                    ' initial x position
                          y&, _                    ' initial y position
                          xFrame&, _               ' initial x size
                          yFrame&, _               ' initial y size
                          %NULL, _                 ' parent window handle
                          %NULL, _                 ' window menu handle
                          hInst&, _                ' program instance handle
                          BYVAL %NULL)             ' creation parameters

  ' Create window for the skin menu 
    hCTLmenu& = skHolder(hFrame&, "SKMENU", 0, 0, CODEPTR(WndProc))
    
    CALL GetClientRect(hCTL&, rc)

    CALL ShowWindow(hFrame&, %SW_SHOW)
    CALL UpdateWindow(hFrame&)
 
    WHILE GetMessage(Msg, %NULL, 0, 0)
        IF skDialogMessage(hFrame&, Msg) = %FALSE THEN
           TranslateMessage Msg
           DispatchMessage Msg
        END IF       
    WEND

    FUNCTION = msg.wParam

END FUNCTION

SUB Config (BYVAL IniFile$, x&, y&, Wdth&, Hght&, BYVAL Action?)
'
' IF Action? = 0  read frame coordinates
' IF Action? <> 0 save frame coordinates

    IF Action? = 0 THEN          ' Read x y frame coordinates
       IF skExist(IniFile$) THEN
	  ErrCode& = skFOpen&(IniFile$, 0, 0, hFile&)
	  IF ErrCode& = 0 THEN Size& = skFlof(hFile&)
       END IF
       IF Size& THEN
	  Buff$ = SPACE$(Size&)
	  ErrCode& = skFGet(hFile&, Buff$)
	  x& = MAX(CVI(MID$(Buff$, 1, 2)), 0)
	  y& = MAX(CVI(MID$(Buff$, 3, 2)), 0)
	  Wdth& = MAX(CVI(MID$(Buff$, 5, 2)), skXmini)
	  Hght& = MAX(CVI(MID$(Buff$, 7, 2)), skYmini)
       ELSE
	  Wdth& = skXmini: Hght& = skYmini
          x& = MAX&((ScrWidth& - Wdth&) \ 2, 0)
          y& = MAX&((ScrHeight& - Hght&) \ 2, 0)
       END IF
    ELSE                        ' Save x y frame coordinates
       CALL skKillFile(IniFile$)
       ErrCode& = skFOpen&(IniFile$, 1, 1, hFile&)
       IF ErrCode& = 0 THEN
	  Buff$ = MKI$(x&) + MKI$(y&) + MKI$(Wdth&) + MKI$(Hght&)
	  ErrCode& = skFPut(hFile&, Buff$)
       END IF
    END IF
    CALL skFClose(hFile&)
    Buff$ = ""

END SUB
